# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields,osv
from unittest2 import result

class res_partner(osv.osv):
    _inherit = 'res.partner'

    _columns = {
        'bodega': fields.boolean('Cellar', help="Check this box if this contact is a cellar."),
        'import_license': fields.char('Import License/VAT'), 
        'accisa': fields.char('ACCISA'), 
        'tax_warehouse': fields.char('TAX Warehouse'), 
        'authorised_warehouse': fields.char('Authorised Warehouse'), 
        'tipo_pallets' : fields.char('Pallet type'),
        'contra_etiquetas' : fields.text('Back label'),
        'transportista' : fields.boolean('Delivery agent'),
    }
    def onchange_bodega(self, cr, uid, ids, bodega, context=None):
        result = {'value':{}}
        if bodega:
            result['value'] = {'customer' : False,'supplier' : True}
        return result
